from .download import download_zip, download_file
from pathlib import Path
down_path = Path(__file__).parent
xz_url = "addons_file"+"/"+down_path.name+"/"
download_zip(xz_url + "assets.zip",down_path)

bl_info = {
    "name" : "MoodID",
    "author" : "May3D", 
    "description" : "",
    "blender" : (4, 1, 1),
    "version" : (1, 0, 0),
    "location" : "",
    "warning" : "",
    "doc_url": "", 
    "tracker_url": "", 
    "category" : "Lighting" 
}


import bpy
import bpy.utils.previews
import os
from bpy_extras.io_utils import ImportHelper, ExportHelper
from bpy.app.handlers import persistent


addon_keymaps = {}
_icons = None
icon_gallery = {'sna_get_images_from_file': [], 'sna_directory_categories': [], 'sna_directory_gallery': [], }


def load_preview_icon(path):
    global _icons
    if not path in _icons:
        if os.path.exists(path):
            _icons.load(path, path, "IMAGE")
        else:
            return 0
    return _icons[path].icon_id


_item_map = dict()


def make_enum_item(_id, name, descr, preview_id, uid):
    lookup = str(_id)+"\0"+str(name)+"\0"+str(descr)+"\0"+str(preview_id)+"\0"+str(uid)
    if not lookup in _item_map:
        _item_map[lookup] = (_id, name, descr, preview_id, uid)
    return _item_map[lookup]


def sna_update_sna_icon_gallery_categories_F420E(self, context):
    sna_updated_prop = self.sna_icon_gallery_categories
    sna_reload_items_18AAF(sna_updated_prop)


def sna_update_sna_icon_gallery_D3C38(self, context):
    sna_updated_prop = self.sna_icon_gallery
    bpy.data.worlds['CL_Shader'].node_tree.nodes['Environment Texture'].image.filepath = sna_updated_prop


def sna_update_sna_use_custom_image_CA208(self, context):
    sna_updated_prop = self.sna_use_custom_image
    if sna_updated_prop:
        bpy.data.worlds['CL_Shader'].node_tree.nodes['Environment Texture'].image.filepath = ''
    else:
        bpy.data.worlds['CL_Shader'].node_tree.nodes['Environment Texture'].image.filepath = os.path.join(os.path.join(os.path.dirname(__file__), 'assets', 'Cold'),'Cold (1).jpg')


def sna_update_sna_enable_D2FC9(self, context):
    sna_updated_prop = self.sna_enable
    if sna_updated_prop:
        if (property_exists("bpy.data.worlds", globals(), locals()) and 'CL_Shader' in bpy.data.worlds):
            pass
        else:
            before_data = list(bpy.data.worlds)
            bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'Assets.blend') + r'\World', filename='CL_Shader', link=False)
            new_data = list(filter(lambda d: not d in before_data, list(bpy.data.worlds)))
            appended_7362D = None if not new_data else new_data[0]
            sna_reset_to_default_99F6F()
        bpy.context.scene.world = bpy.data.worlds['CL_Shader']
    else:
        bpy.data.worlds.remove(world=bpy.data.worlds['CL_Shader'], )
        # Iterate over all images in the blend file
        for image in bpy.data.images:
            # Check if "Palette" is in the image name
            if "Preset" in image.name:
                # Print the name of the image being deleted
                print(f"Deleting image: {image.name}")
                # Remove the image from the blend file
                bpy.data.images.remove(image)
        bpy.data.node_groups.remove(tree=bpy.data.node_groups['FakeHDR'], )
        bpy.data.node_groups.remove(tree=bpy.data.node_groups['Vector'], )


def property_exists(prop_path, glob, loc):
    try:
        eval(prop_path, glob, loc)
        return True
    except:
        return False


def sna_icon_gallery_func_D7F96(layout_function, ):
    box_C41BC = layout_function.box()
    box_C41BC.alert = False
    box_C41BC.enabled = True
    box_C41BC.active = True
    box_C41BC.use_property_split = False
    box_C41BC.use_property_decorate = False
    box_C41BC.alignment = 'Expand'.upper()
    box_C41BC.scale_x = 1.0
    box_C41BC.scale_y = 1.0
    if not True: box_C41BC.operator_context = "EXEC_DEFAULT"
    box_C41BC.prop(bpy.context.scene, 'sna_view_palettes_prop', text='Palettes', icon_value=(11 if bpy.context.scene.sna_view_palettes_prop else 10), emboss=False)
    if bpy.context.scene.sna_view_palettes_prop:
        col_FB607 = box_C41BC.column(heading='', align=True)
        col_FB607.alert = False
        col_FB607.enabled = True
        col_FB607.active = True
        col_FB607.use_property_split = False
        col_FB607.use_property_decorate = False
        col_FB607.scale_x = 1.0
        col_FB607.scale_y = 1.0
        col_FB607.alignment = 'Expand'.upper()
        col_FB607.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        if bpy.context.scene.sna_use_custom_image:
            col_8A147 = col_FB607.column(heading='', align=True)
            col_8A147.alert = False
            col_8A147.enabled = True
            col_8A147.active = True
            col_8A147.use_property_split = False
            col_8A147.use_property_decorate = False
            col_8A147.scale_x = 1.0
            col_8A147.scale_y = 1.0
            col_8A147.alignment = 'Expand'.upper()
            col_8A147.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            col_8A147.separator(factor=1.0)
            box_F3DF7 = col_8A147.box()
            box_F3DF7.alert = False
            box_F3DF7.enabled = True
            box_F3DF7.active = True
            box_F3DF7.use_property_split = False
            box_F3DF7.use_property_decorate = False
            box_F3DF7.alignment = 'Expand'.upper()
            box_F3DF7.scale_x = 1.0
            box_F3DF7.scale_y = 0.8999999761581421
            if not True: box_F3DF7.operator_context = "EXEC_DEFAULT"
            box_F3DF7.template_icon(icon_value=load_preview_icon(str(bpy.data.worlds['CL_Shader'].node_tree.nodes['Environment Texture'].image.filepath)), scale=5.0)
            col_8A147.separator(factor=0.20999999344348907)
            op = col_8A147.operator('sna.select_image_5c640', text='Select Custom Image', icon_value=693, emboss=True, depress=False)
        else:
            col_3B4E5 = col_FB607.column(heading='', align=True)
            col_3B4E5.alert = False
            col_3B4E5.enabled = True
            col_3B4E5.active = True
            col_3B4E5.use_property_split = False
            col_3B4E5.use_property_decorate = False
            col_3B4E5.scale_x = 1.0
            col_3B4E5.scale_y = 1.0
            col_3B4E5.alignment = 'Expand'.upper()
            col_3B4E5.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            col_3B4E5.prop(bpy.context.scene, 'sna_icon_gallery_categories', text='', icon_value=0, emboss=True)
            col_EC33A = col_3B4E5.column(heading='', align=True)
            col_EC33A.alert = False
            col_EC33A.enabled = True
            col_EC33A.active = True
            col_EC33A.use_property_split = False
            col_EC33A.use_property_decorate = False
            col_EC33A.scale_x = 1.0
            col_EC33A.scale_y = 1.0
            col_EC33A.alignment = 'Expand'.upper()
            col_EC33A.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            col_EC33A.separator(factor=1.0)
            row_A2ADD = col_EC33A.row(heading='', align=True)
            row_A2ADD.alert = False
            row_A2ADD.enabled = True
            row_A2ADD.active = True
            row_A2ADD.use_property_split = False
            row_A2ADD.use_property_decorate = False
            row_A2ADD.scale_x = 1.0
            row_A2ADD.scale_y = 1.0
            row_A2ADD.alignment = 'Expand'.upper()
            row_A2ADD.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            row_A2ADD.template_icon_view(bpy.context.scene, 'sna_icon_gallery', show_labels=False, scale=5.0, scale_popup=5.0)
            row_48887 = row_A2ADD.row(heading='', align=False)
            row_48887.alert = False
            row_48887.enabled = True
            row_48887.active = True
            row_48887.use_property_split = False
            row_48887.use_property_decorate = False
            row_48887.scale_x = 1.0
            row_48887.scale_y = 5.0
            row_48887.alignment = 'Expand'.upper()
            row_48887.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            op = col_EC33A.operator('sna.reload_db542', text='刷新预设', icon_value=692, emboss=True, depress=False)
        col_FB607.separator(factor=1.0)
        col_FB607.prop(bpy.context.scene, 'sna_use_custom_image', text='使用自定义图像', icon_value=0, emboss=True)


def sna_icon_gallery_enum_items(self, context):
    enum_items = icon_gallery['sna_directory_gallery']
    return [make_enum_item(item[0], item[1], item[2], item[3], i) for i, item in enumerate(enum_items)]


class SNA_OT_Reload_Db542(bpy.types.Operator):
    bl_idname = "sna.reload_db542"
    bl_label = "Reload"
    bl_description = "Reloads the icon gallery and all palettes. May take a minute or two"
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        sna_reload_categories_D711C()
        sna_reset_to_default_99F6F()
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Select_Image_5C640(bpy.types.Operator, ImportHelper):
    bl_idname = "sna.select_image_5c640"
    bl_label = "Select Image"
    bl_description = "Select a custom image to use as the color palette"
    bl_options = {"REGISTER", "UNDO"}
    filter_glob: bpy.props.StringProperty( default='*.png;*.jpg;*.exr', options={'HIDDEN'} )

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        bpy.data.worlds['CL_Shader'].node_tree.nodes['Environment Texture'].image.filepath = self.filepath
        return {"FINISHED"}


def sna_reload_categories_D711C():
    icon_gallery['sna_directory_categories'] = []
    for i_347C4 in range(len([os.path.join(os.path.join(os.path.dirname(__file__), 'assets', 'All Palettes'), f) for f in os.listdir(os.path.join(os.path.dirname(__file__), 'assets', 'All Palettes')) if os.path.isdir(os.path.join(os.path.join(os.path.dirname(__file__), 'assets', 'All Palettes'), f))])):
        icon_gallery['sna_directory_categories'].append([os.path.basename([os.path.join(os.path.join(os.path.dirname(__file__), 'assets', 'All Palettes'), f) for f in os.listdir(os.path.join(os.path.dirname(__file__), 'assets', 'All Palettes')) if os.path.isdir(os.path.join(os.path.join(os.path.dirname(__file__), 'assets', 'All Palettes'), f))][i_347C4]), os.path.basename([os.path.join(os.path.join(os.path.dirname(__file__), 'assets', 'All Palettes'), f) for f in os.listdir(os.path.join(os.path.dirname(__file__), 'assets', 'All Palettes')) if os.path.isdir(os.path.join(os.path.join(os.path.dirname(__file__), 'assets', 'All Palettes'), f))][i_347C4]), '', 0])


def sna_icon_gallery_categories_enum_items(self, context):
    enum_items = icon_gallery['sna_directory_categories']
    return [make_enum_item(item[0], item[1], item[2], item[3], i) for i, item in enumerate(enum_items)]


def sna_reload_items_18AAF(Property_Update_Value):
    icon_gallery['sna_directory_gallery'] = []
    for i_6BB84 in range(len([os.path.join(os.path.join(os.path.join(os.path.dirname(__file__), 'assets', 'All Palettes'),Property_Update_Value), f) for f in os.listdir(os.path.join(os.path.join(os.path.dirname(__file__), 'assets', 'All Palettes'),Property_Update_Value)) if os.path.isfile(os.path.join(os.path.join(os.path.join(os.path.dirname(__file__), 'assets', 'All Palettes'),Property_Update_Value), f))])):
        icon_gallery['sna_directory_gallery'].append([[os.path.join(os.path.join(os.path.join(os.path.dirname(__file__), 'assets', 'All Palettes'),Property_Update_Value), f) for f in os.listdir(os.path.join(os.path.join(os.path.dirname(__file__), 'assets', 'All Palettes'),Property_Update_Value)) if os.path.isfile(os.path.join(os.path.join(os.path.join(os.path.dirname(__file__), 'assets', 'All Palettes'),Property_Update_Value), f))][i_6BB84], [os.path.join(os.path.join(os.path.join(os.path.dirname(__file__), 'assets', 'All Palettes'),Property_Update_Value), f) for f in os.listdir(os.path.join(os.path.join(os.path.dirname(__file__), 'assets', 'All Palettes'),Property_Update_Value)) if os.path.isfile(os.path.join(os.path.join(os.path.join(os.path.dirname(__file__), 'assets', 'All Palettes'),Property_Update_Value), f))][i_6BB84], '', load_preview_icon([os.path.join(os.path.join(os.path.join(os.path.dirname(__file__), 'assets', 'All Palettes'),Property_Update_Value), f) for f in os.listdir(os.path.join(os.path.join(os.path.dirname(__file__), 'assets', 'All Palettes'),Property_Update_Value)) if os.path.isfile(os.path.join(os.path.join(os.path.join(os.path.dirname(__file__), 'assets', 'All Palettes'),Property_Update_Value), f))][i_6BB84])])


@persistent
def load_pre_handler_E9840(dummy):
    sna_reload_categories_D711C()
    sna_reset_to_default_99F6F()


def sna_reset_to_default_99F6F():
    sna_reload_categories_D711C()
    sna_reload_items_18AAF('Cold')
    bpy.context.scene.sna_icon_gallery_categories = 'Cold'
    bpy.data.worlds['CL_Shader'].node_tree.nodes['Environment Texture'].image.filepath = os.path.join(os.path.join(os.path.dirname(__file__), 'assets', 'Cold'),'Cold (1).jpg')


class SNA_PT_MOODID_A9ED9(bpy.types.Panel):
    bl_label = 'MoodID'
    bl_idname = 'SNA_PT_MOODID_A9ED9'
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_context = ''
    bl_category = 'MoodID'
    bl_order = 0
    bl_ui_units_x=0

    @classmethod
    def poll(cls, context):
        return not (False)

    def draw_header(self, context):
        layout = self.layout

    def draw(self, context):
        layout = self.layout
        col_B98A4 = layout.column(heading='', align=False)
        col_B98A4.alert = False
        col_B98A4.enabled = True
        col_B98A4.active = True
        col_B98A4.use_property_split = False
        col_B98A4.use_property_decorate = False
        col_B98A4.scale_x = 1.2999999523162842
        col_B98A4.scale_y = 1.2999999523162842
        col_B98A4.alignment = 'Expand'.upper()
        col_B98A4.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        col_B98A4.prop(bpy.context.scene, 'sna_enable', text=('On' if bpy.context.scene.sna_enable else 'Off'), icon_value=(_icons['cyberscooty-switch-on.png'].icon_id if bpy.context.scene.sna_enable else _icons['cyberscooty-switch-off.png'].icon_id), emboss=True)
        if bpy.context.scene.sna_enable:
            layout.separator(factor=-3.3199996948242188)
            layout_function = layout
            sna_icon_gallery_func_D7F96(layout_function, )
        if bpy.context.scene.sna_enable:
            box_A6551 = layout.box()
            box_A6551.alert = False
            box_A6551.enabled = True
            box_A6551.active = True
            box_A6551.use_property_split = False
            box_A6551.use_property_decorate = False
            box_A6551.alignment = 'Expand'.upper()
            box_A6551.scale_x = 1.0
            box_A6551.scale_y = 1.0
            if not True: box_A6551.operator_context = "EXEC_DEFAULT"
            box_A6551.prop(bpy.context.scene, 'sna_view_shader_properties', text='Properties', icon_value=(11 if bpy.context.scene.sna_view_shader_properties else 10), emboss=False)
            if bpy.context.scene.sna_view_shader_properties:
                col_8643E = box_A6551.column(heading='', align=False)
                col_8643E.alert = False
                col_8643E.enabled = True
                col_8643E.active = True
                col_8643E.use_property_split = False
                col_8643E.use_property_decorate = False
                col_8643E.scale_x = 1.0
                col_8643E.scale_y = 1.0
                col_8643E.alignment = 'Expand'.upper()
                col_8643E.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                col_8643E.separator(factor=1.0)
                col_3C94A = col_8643E.column(heading='', align=True)
                col_3C94A.alert = False
                col_3C94A.enabled = True
                col_3C94A.active = True
                col_3C94A.use_property_split = True
                col_3C94A.use_property_decorate = True
                col_3C94A.scale_x = 1.0
                col_3C94A.scale_y = 1.0
                col_3C94A.alignment = 'Expand'.upper()
                col_3C94A.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                box_EAC2A = col_3C94A.box()
                box_EAC2A.alert = False
                box_EAC2A.enabled = True
                box_EAC2A.active = True
                box_EAC2A.use_property_split = False
                box_EAC2A.use_property_decorate = False
                box_EAC2A.alignment = 'Expand'.upper()
                box_EAC2A.scale_x = 1.0
                box_EAC2A.scale_y = 1.0
                if not True: box_EAC2A.operator_context = "EXEC_DEFAULT"
                col_055A1 = box_EAC2A.column(heading='', align=True)
                col_055A1.alert = False
                col_055A1.enabled = True
                col_055A1.active = True
                col_055A1.use_property_split = True
                col_055A1.use_property_decorate = True
                col_055A1.scale_x = 1.0
                col_055A1.scale_y = 1.0
                col_055A1.alignment = 'Expand'.upper()
                col_055A1.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                col_055A1.separator(factor=0.25)
                col_055A1.prop(bpy.data.worlds['CL_Shader'].node_tree.nodes['Group'].inputs[1], 'default_value', text='Brightness', icon_value=0, emboss=True)
                col_055A1.separator(factor=0.25)
                box_B4D8F = col_3C94A.box()
                box_B4D8F.alert = False
                box_B4D8F.enabled = True
                box_B4D8F.active = True
                box_B4D8F.use_property_split = False
                box_B4D8F.use_property_decorate = False
                box_B4D8F.alignment = 'Expand'.upper()
                box_B4D8F.scale_x = 1.0
                box_B4D8F.scale_y = 1.0
                if not True: box_B4D8F.operator_context = "EXEC_DEFAULT"
                col_9C4BB = box_B4D8F.column(heading='', align=True)
                col_9C4BB.alert = False
                col_9C4BB.enabled = True
                col_9C4BB.active = True
                col_9C4BB.use_property_split = True
                col_9C4BB.use_property_decorate = True
                col_9C4BB.scale_x = 1.0
                col_9C4BB.scale_y = 1.0
                col_9C4BB.alignment = 'Expand'.upper()
                col_9C4BB.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                col_9C4BB.separator(factor=0.25)
                col_9C4BB.prop(bpy.data.worlds['CL_Shader'].node_tree.nodes['Group'].inputs[2], 'default_value', text='Gamma', icon_value=0, emboss=True)
                col_9C4BB.prop(bpy.data.worlds['CL_Shader'].node_tree.nodes['Group'].inputs[3], 'default_value', text='Hue', icon_value=0, emboss=True)
                col_9C4BB.prop(bpy.data.worlds['CL_Shader'].node_tree.nodes['Group'].inputs[4], 'default_value', text='Saturation', icon_value=0, emboss=True)
                col_9C4BB.separator(factor=0.25)
                box_0926D = col_3C94A.box()
                box_0926D.alert = False
                box_0926D.enabled = True
                box_0926D.active = True
                box_0926D.use_property_split = False
                box_0926D.use_property_decorate = False
                box_0926D.alignment = 'Expand'.upper()
                box_0926D.scale_x = 1.0
                box_0926D.scale_y = 1.0
                if not True: box_0926D.operator_context = "EXEC_DEFAULT"
                col_AE5EB = box_0926D.column(heading='', align=True)
                col_AE5EB.alert = False
                col_AE5EB.enabled = True
                col_AE5EB.active = True
                col_AE5EB.use_property_split = True
                col_AE5EB.use_property_decorate = True
                col_AE5EB.scale_x = 1.0
                col_AE5EB.scale_y = 1.0
                col_AE5EB.alignment = 'Expand'.upper()
                col_AE5EB.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                col_AE5EB.separator(factor=0.25)
                col_AE5EB.prop(bpy.data.worlds['CL_Shader'].node_tree.nodes['Group'].inputs[5], 'default_value', text='Highlights', icon_value=0, emboss=True)
                col_AE5EB.prop(bpy.data.worlds['CL_Shader'].node_tree.nodes['Group'].inputs[6], 'default_value', text='Midtones', icon_value=0, emboss=True)
                col_AE5EB.prop(bpy.data.worlds['CL_Shader'].node_tree.nodes['Group'].inputs[7], 'default_value', text='Shadows', icon_value=0, emboss=True)
                col_AE5EB.separator(factor=0.25)
                box_1139A = col_3C94A.box()
                box_1139A.alert = False
                box_1139A.enabled = True
                box_1139A.active = True
                box_1139A.use_property_split = False
                box_1139A.use_property_decorate = False
                box_1139A.alignment = 'Expand'.upper()
                box_1139A.scale_x = 1.0
                box_1139A.scale_y = 1.0
                if not True: box_1139A.operator_context = "EXEC_DEFAULT"
                col_32C12 = box_1139A.column(heading='', align=True)
                col_32C12.alert = False
                col_32C12.enabled = True
                col_32C12.active = True
                col_32C12.use_property_split = True
                col_32C12.use_property_decorate = True
                col_32C12.scale_x = 1.0
                col_32C12.scale_y = 1.0
                col_32C12.alignment = 'Expand'.upper()
                col_32C12.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                col_32C12.separator(factor=0.25)
                col_32C12.prop(bpy.data.worlds['CL_Shader'].node_tree.nodes['Group.001'].inputs[0], 'default_value', text='Blur', icon_value=0, emboss=True)
                col_32C12.separator(factor=0.25)
                box_8363A = col_3C94A.box()
                box_8363A.alert = False
                box_8363A.enabled = True
                box_8363A.active = True
                box_8363A.use_property_split = False
                box_8363A.use_property_decorate = False
                box_8363A.alignment = 'Expand'.upper()
                box_8363A.scale_x = 1.0
                box_8363A.scale_y = 1.0
                if not True: box_8363A.operator_context = "EXEC_DEFAULT"
                col_EAB4F = box_8363A.column(heading='', align=True)
                col_EAB4F.alert = False
                col_EAB4F.enabled = True
                col_EAB4F.active = True
                col_EAB4F.use_property_split = True
                col_EAB4F.use_property_decorate = True
                col_EAB4F.scale_x = 1.0
                col_EAB4F.scale_y = 1.0
                col_EAB4F.alignment = 'Expand'.upper()
                col_EAB4F.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                col_EAB4F.separator(factor=1.0)
                col_EAB4F.prop(bpy.data.worlds['CL_Shader'].node_tree.nodes['Group.001'].inputs[1], 'default_value', text='X Location', icon_value=0, emboss=True)
                col_EAB4F.prop(bpy.data.worlds['CL_Shader'].node_tree.nodes['Group.001'].inputs[2], 'default_value', text='Y Location', icon_value=0, emboss=True)
                col_EAB4F.prop(bpy.data.worlds['CL_Shader'].node_tree.nodes['Group.001'].inputs[3], 'default_value', text='Z Location', icon_value=0, emboss=True)
                col_EAB4F.separator(factor=1.0)
                box_CEABA = col_3C94A.box()
                box_CEABA.alert = False
                box_CEABA.enabled = True
                box_CEABA.active = True
                box_CEABA.use_property_split = False
                box_CEABA.use_property_decorate = False
                box_CEABA.alignment = 'Expand'.upper()
                box_CEABA.scale_x = 1.0
                box_CEABA.scale_y = 1.0
                if not True: box_CEABA.operator_context = "EXEC_DEFAULT"
                col_8F829 = box_CEABA.column(heading='', align=True)
                col_8F829.alert = False
                col_8F829.enabled = True
                col_8F829.active = True
                col_8F829.use_property_split = True
                col_8F829.use_property_decorate = True
                col_8F829.scale_x = 1.0
                col_8F829.scale_y = 1.0
                col_8F829.alignment = 'Expand'.upper()
                col_8F829.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                col_8F829.separator(factor=0.25)
                col_8F829.prop(bpy.data.worlds['CL_Shader'].node_tree.nodes['Group.001'].inputs[4], 'default_value', text='X Rotation', icon_value=0, emboss=True)
                col_8F829.prop(bpy.data.worlds['CL_Shader'].node_tree.nodes['Group.001'].inputs[5], 'default_value', text='Y Rotation', icon_value=0, emboss=True)
                col_8F829.prop(bpy.data.worlds['CL_Shader'].node_tree.nodes['Group.001'].inputs[6], 'default_value', text='Z Rotation', icon_value=0, emboss=True)
                col_8F829.separator(factor=0.25)
                box_3793A = col_3C94A.box()
                box_3793A.alert = False
                box_3793A.enabled = True
                box_3793A.active = True
                box_3793A.use_property_split = False
                box_3793A.use_property_decorate = False
                box_3793A.alignment = 'Expand'.upper()
                box_3793A.scale_x = 1.0
                box_3793A.scale_y = 1.0
                if not True: box_3793A.operator_context = "EXEC_DEFAULT"
                col_7B098 = box_3793A.column(heading='', align=True)
                col_7B098.alert = False
                col_7B098.enabled = True
                col_7B098.active = True
                col_7B098.use_property_split = True
                col_7B098.use_property_decorate = True
                col_7B098.scale_x = 1.0
                col_7B098.scale_y = 1.0
                col_7B098.alignment = 'Expand'.upper()
                col_7B098.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                col_7B098.separator(factor=0.25)
                col_7B098.prop(bpy.data.worlds['CL_Shader'].node_tree.nodes['Group.001'].inputs[7], 'default_value', text='X Scale', icon_value=0, emboss=True)
                col_7B098.prop(bpy.data.worlds['CL_Shader'].node_tree.nodes['Group.001'].inputs[8], 'default_value', text='Y Scale', icon_value=0, emboss=True)
                col_7B098.prop(bpy.data.worlds['CL_Shader'].node_tree.nodes['Group.001'].inputs[9], 'default_value', text='Z Scale', icon_value=0, emboss=True)
                box_01895 = col_3C94A.box()
                box_01895.alert = False
                box_01895.enabled = True
                box_01895.active = True
                box_01895.use_property_split = False
                box_01895.use_property_decorate = False
                box_01895.alignment = 'Expand'.upper()
                box_01895.scale_x = 1.0
                box_01895.scale_y = 1.0
                if not True: box_01895.operator_context = "EXEC_DEFAULT"
                col_AF000 = box_01895.column(heading='', align=True)
                col_AF000.alert = False
                col_AF000.enabled = True
                col_AF000.active = True
                col_AF000.use_property_split = True
                col_AF000.use_property_decorate = True
                col_AF000.scale_x = 1.0
                col_AF000.scale_y = 1.0
                col_AF000.alignment = 'Expand'.upper()
                col_AF000.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                col_AF000.separator(factor=0.25)
                col_AF000.prop(bpy.data.worlds['CL_Shader'].node_tree.nodes['Group.001'].inputs[10], 'default_value', text='制作调色板', icon_value=(39 if bpy.data.worlds['CL_Shader'].node_tree.nodes['Group.001'].inputs[10].default_value else 38), emboss=True)
                col_3E8C4 = col_AF000.column(heading='', align=True)
                col_3E8C4.alert = False
                col_3E8C4.enabled = bpy.data.worlds['CL_Shader'].node_tree.nodes['Group.001'].inputs[10].default_value
                col_3E8C4.active = True
                col_3E8C4.use_property_split = True
                col_3E8C4.use_property_decorate = True
                col_3E8C4.scale_x = 1.0
                col_3E8C4.scale_y = 1.0
                col_3E8C4.alignment = 'Expand'.upper()
                col_3E8C4.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                col_3E8C4.prop(bpy.data.worlds['CL_Shader'].node_tree.nodes['Group.001'].inputs[11], 'default_value', text='调色板分辨率', icon_value=0, emboss=True)


def register():
    global _icons
    _icons = bpy.utils.previews.new()
    bpy.types.Scene.sna_enable = bpy.props.BoolProperty(name='Enable', description='Enabling will append and use the shader. Disabling will delete the shader and any changes you may have made', default=False, update=sna_update_sna_enable_D2FC9)
    bpy.types.Scene.sna_view_shader_properties = bpy.props.BoolProperty(name='View Shader Properties', description='', default=False)
    bpy.types.Scene.sna_icon_gallery = bpy.props.EnumProperty(name='Icon Gallery', description='', items=sna_icon_gallery_enum_items, update=sna_update_sna_icon_gallery_D3C38)
    bpy.types.Scene.sna_icon_gallery_categories = bpy.props.EnumProperty(name='Icon Gallery Categories', description='', items=sna_icon_gallery_categories_enum_items, update=sna_update_sna_icon_gallery_categories_F420E)
    bpy.types.Scene.sna_view_palettes_prop = bpy.props.BoolProperty(name='View Palettes Prop', description='', default=False)
    bpy.types.Scene.sna_use_custom_image_prop = bpy.props.BoolProperty(name='Use Custom Image Prop', description='', default=False)
    bpy.types.Scene.sna_use_custom_image = bpy.props.BoolProperty(name='Use Custom Image', description='Select this to use a custom image instead of a preset color palette', default=False, update=sna_update_sna_use_custom_image_CA208)
    bpy.utils.register_class(SNA_OT_Reload_Db542)
    bpy.utils.register_class(SNA_OT_Select_Image_5C640)
    bpy.app.handlers.load_pre.append(load_pre_handler_E9840)
    bpy.utils.register_class(SNA_PT_MOODID_A9ED9)
    if not 'cyberscooty-switch-off.png' in _icons: _icons.load('cyberscooty-switch-off.png', os.path.join(os.path.dirname(__file__), 'icons', 'cyberscooty-switch-off.png'), "IMAGE")
    if not 'cyberscooty-switch-on.png' in _icons: _icons.load('cyberscooty-switch-on.png', os.path.join(os.path.dirname(__file__), 'icons', 'cyberscooty-switch-on.png'), "IMAGE")


def unregister():
    global _icons
    bpy.utils.previews.remove(_icons)
    wm = bpy.context.window_manager
    kc = wm.keyconfigs.addon
    for km, kmi in addon_keymaps.values():
        km.keymap_items.remove(kmi)
    addon_keymaps.clear()
    del bpy.types.Scene.sna_use_custom_image
    del bpy.types.Scene.sna_use_custom_image_prop
    del bpy.types.Scene.sna_view_palettes_prop
    del bpy.types.Scene.sna_icon_gallery_categories
    del bpy.types.Scene.sna_icon_gallery
    del bpy.types.Scene.sna_view_shader_properties
    del bpy.types.Scene.sna_enable
    bpy.utils.unregister_class(SNA_OT_Reload_Db542)
    bpy.utils.unregister_class(SNA_OT_Select_Image_5C640)
    bpy.app.handlers.load_pre.remove(load_pre_handler_E9840)
    bpy.utils.unregister_class(SNA_PT_MOODID_A9ED9)
